#include "xprintf.h"
#include <stdint.h>
#include <math.h>
#include "driver.h"

#define MIN    100000
#define MAX    100000000

void prim()
{
    uint32_t  x, i, limit;
    char linecount = 0;

    xprintf("Berechne alle primzahlen von 0 bis %lu\r\r",(long)MAX);

    for (x = 3; x <= MAX; x+=2)
    {
        limit = sqrtf(x)+1;

        for (i = 3; i < limit; i++)
        {
            if (x % i == 0)
                break;          // Rest = 0 Teiler gefunden
        }

        // Nur drucken, wenn limit erreicht wurde und kein Teiler
        if (i >= limit) {
            SetLedByte((char)x & 0xff);
            SEG7  = (char)x & 0xff;
            xprintf("%10lu  ", x);
            if (++linecount >= 6)
            {
                xprintf("\r");
                linecount=0;
            }
        }

    }
    xprintf("\rFertig\r");

}

